import { AnyBaseNode, AnyNode, DefinitionMap } from '@onetyped/core';
import ts from 'typescript';
type CustomTypeMap = Map<number, {
    symbol: ts.Symbol;
    name: string;
}>;
type FromTypeOptions = {
    type: ts.Type;
    locationNode: ts.Node;
    checker: ts.TypeChecker;
    /**
     * only stable within a single TS program
     */
    typeCache?: DefinitionMap;
    /**
     * A map of custom types that you don't want to 'dig' into but instead
     * return a simpler node object for.
     */
    customTypes?: CustomTypeMap;
    definitionNodeType?: 'named' | 'definitionReference';
};
type FromTypeResolvedOptions = Required<FromTypeOptions>;
export declare const fromType: (options: FromTypeOptions) => {
    node: AnyNode;
    typeCache: DefinitionMap;
};
export declare const createOrReferenceSymbolDefinition: (typeArguments: readonly ts.Type[], options: FromTypeResolvedOptions) => AnyBaseNode;
export declare const fromTypeInternal: (options: FromTypeResolvedOptions) => AnyNode;
export {};
//# sourceMappingURL=from-type.d.ts.map