"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  fromType: () => fromType,
  printNode: () => printNode,
  toTypeNode: () => toTypeNode
});
module.exports = __toCommonJS(src_exports);

// src/from-type.ts
var import_core = require("@onetyped/core");
var import_typescript = __toESM(require("typescript"), 1);
var hasFlag = (type, flag) => {
  return (type.flags & flag) === flag;
};
var hasSymbolFlag = (symbol, flag) => {
  return (symbol.flags & flag) === flag;
};
var hasObjectFlag = (type, flag) => {
  return (type.objectFlags & flag) === flag;
};
var getStringHash = (string_) => {
  let hash = 0;
  for (let index = 0, length = string_.length; index < length; index++) {
    const chr = string_.charCodeAt(index);
    hash = (hash << 5) - hash + chr;
    hash = Math.trunc(hash);
  }
  return hash >>> 0;
};
var getNodeFromCallSignatures = (callSignatures, options) => {
  if (callSignatures.length > 0) {
    const nodeCallSignatures = callSignatures.map((signature) => {
      const parameters = signature.getParameters().map((parameter) => {
        const parameterType = options.checker.getTypeOfSymbolAtLocation(
          parameter,
          options.locationNode
        );
        return fromTypeInternal({
          ...options,
          type: parameterType
        });
      });
      const returnType = options.checker.getReturnTypeOfSignature(signature);
      const functionNode = (0, import_core.func)({
        arguments: parameters,
        return: fromTypeInternal({
          ...options,
          type: returnType
        })
      });
      return functionNode;
    });
    return (0, import_core.unionIfMultiple)(nodeCallSignatures);
  }
};
var fromType = (options) => {
  const typeCache = options.typeCache ?? /* @__PURE__ */ new Map();
  const customTypes = options.customTypes ?? /* @__PURE__ */ new Map();
  const definitionNodeType = options.definitionNodeType ?? "named";
  return {
    node: fromTypeInternal({
      ...options,
      typeCache,
      customTypes,
      definitionNodeType
    }),
    typeCache
  };
};
var createOrReferenceSymbolDefinition = (typeArguments, options) => {
  const { type, checker, typeCache, definitionNodeType } = options;
  const idObjectHash = JSON.stringify({
    id: type.id,
    typeArgIds: typeArguments.map(
      (typeArgument) => typeArgument.id
    )
  });
  const hash = `type_${getStringHash(idObjectHash)}`;
  const typeString = checker.typeToString(type);
  const symbolNode = typeCache.get(hash);
  if (symbolNode) {
    if (definitionNodeType === "definitionReference") {
      return (0, import_core.definitionReference)(hash, typeString);
    }
    return symbolNode;
  }
  const newType = Object.assign(
    Object.create(Object.getPrototypeOf(type)),
    type
  );
  newType._mustResolve = true;
  if (definitionNodeType === "definitionReference") {
    typeCache.set(hash, (0, import_core.unknown)());
    const node2 = fromTypeInternal({
      ...options,
      type: newType
    });
    typeCache.set(hash, node2);
    return (0, import_core.definitionReference)(hash, typeString);
  }
  const node = (0, import_core.named)(null, typeString);
  typeCache.set(hash, node);
  node.node = fromTypeInternal({
    ...options,
    type: newType
  });
  return node.node;
};
var fromTypeInternal = (options) => {
  const { type, checker, locationNode, customTypes } = options;
  if (hasFlag(type, import_typescript.default.TypeFlags.String)) {
    return (0, import_core.string)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Number)) {
    return (0, import_core.number)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Boolean)) {
    return (0, import_core.boolean)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Null)) {
    return (0, import_core.nullType)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Undefined)) {
    return (0, import_core.undefinedType)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Unknown)) {
    return (0, import_core.unknown)();
  }
  if (type.isLiteral()) {
    if (typeof type.value === "object") {
      const bigIntLiteral = BigInt(
        `${type.value.negative ? "-" : ""}${type.value.base10Value}`
      );
      return (0, import_core.literal)(bigIntLiteral);
    }
    return (0, import_core.literal)(type.value);
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.BooleanLiteral)) {
    const literalType = checker.typeToString(type);
    return (0, import_core.literal)(literalType === "true");
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.TemplateLiteral)) {
    return (0, import_core.literal)(checker.typeToString(type));
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Void)) {
    return (0, import_core.voidType)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Any)) {
    return (0, import_core.any)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Never)) {
    return (0, import_core.never)();
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.BigInt)) {
    return (0, import_core.bigint)();
  }
  const symbol = type.getSymbol();
  if (symbol) {
    const customType = customTypes.get(symbol.id);
    if (customType) {
      const arguments_ = type.aliasTypeArguments?.map((argument) => {
        return fromTypeInternal({
          ...options,
          type: argument
        });
      });
      return (0, import_core.custom)(customType.name, arguments_);
    }
    switch (symbol.name) {
      case "Array":
      case "ReadonlyArray": {
        const typeArguments = checker.getTypeArguments(type);
        return (0, import_core.array)(
          fromTypeInternal({
            ...options,
            type: typeArguments[0]
          })
        );
      }
      case "Iterable":
      case "IterableIterator": {
        const typeArguments = checker.getTypeArguments(type);
        return (0, import_core.iterator)(
          fromTypeInternal({
            ...options,
            type: typeArguments[0]
          })
        );
      }
      case "Date": {
        return (0, import_core.date)();
      }
      case "RegExp": {
        return (0, import_core.regexp)();
      }
      case "Set": {
        const typeArguments = checker.getTypeArguments(type);
        return (0, import_core.set)(fromTypeInternal({ ...options, type: typeArguments[0] }));
      }
      case "Map": {
        const typeArguments = checker.getTypeArguments(type);
        return (0, import_core.map)(
          fromTypeInternal({
            ...options,
            type: typeArguments[0]
          }),
          fromTypeInternal({
            ...options,
            type: typeArguments[1]
          })
        );
      }
      case "FormData": {
        return (0, import_core.formData)();
      }
      case "File": {
        return (0, import_core.file)();
      }
      case "Blob": {
        return (0, import_core.blob)();
      }
    }
    if (symbol.name !== "__type" && symbol.name !== "__object" && !type._mustResolve) {
      return createOrReferenceSymbolDefinition(
        checker.getTypeArguments(type),
        options
      );
    }
  }
  const aliasSymbol = type.aliasSymbol;
  const aliasTypeArguments = type.aliasTypeArguments;
  if (aliasSymbol) {
    const customType = customTypes.get(aliasSymbol.id);
    if (customType) {
      const arguments_ = aliasTypeArguments?.map((argument) => {
        return fromTypeInternal({
          ...options,
          type: argument
        });
      });
      return (0, import_core.custom)(customType.name, arguments_);
    }
  }
  if (aliasSymbol?.escapedName === "Record" && aliasTypeArguments?.length === 2) {
    return (0, import_core.record)(
      fromTypeInternal({
        ...options,
        type: aliasTypeArguments[0]
      }),
      fromTypeInternal({
        ...options,
        type: aliasTypeArguments[1]
      })
    );
  }
  if (aliasSymbol && !type._mustResolve) {
    return createOrReferenceSymbolDefinition(aliasTypeArguments ?? [], options);
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.Object)) {
    const objectType = type;
    if (hasObjectFlag(objectType, import_typescript.default.ObjectFlags.Reference)) {
      const { target } = type;
      if (hasObjectFlag(target, import_typescript.default.ObjectFlags.Tuple)) {
        const tupleType = type;
        const target2 = tupleType.target;
        const tupleTypes = tupleType.typeArguments?.map((typeArgument, index) => {
          const elementFlags = target2.elementFlags[index];
          const node = fromTypeInternal({
            ...options,
            type: typeArgument
          });
          if (elementFlags & import_typescript.default.ElementFlags.Optional) {
            return (0, import_core.optional)(node);
          }
          return node;
        }) ?? [];
        return (0, import_core.tuple)(tupleTypes);
      }
    }
    const nodes = [];
    const keyTypes = [];
    let valueType;
    const stringIndexType = objectType.getStringIndexType();
    if (stringIndexType) {
      keyTypes.push((0, import_core.string)());
      valueType = fromTypeInternal({
        ...options,
        type: stringIndexType
      });
    }
    const numberIndexType = objectType.getNumberIndexType();
    if (numberIndexType) {
      keyTypes.push((0, import_core.number)());
      if (!valueType) {
        valueType = fromTypeInternal({
          ...options,
          type: numberIndexType
        });
      }
    }
    if (keyTypes.length > 0 && valueType) {
      nodes.push(
        (0, import_core.record)(
          (0, import_core.unionIfMultiple)(
            keyTypes
          ),
          valueType
        )
      );
    }
    const propertyEntries = type.getProperties().map((property) => {
      const propertyType = checker.getTypeOfSymbolAtLocation(
        property,
        locationNode
      );
      let node = fromTypeInternal({
        ...options,
        type: propertyType
      });
      if (hasSymbolFlag(property, import_typescript.default.SymbolFlags.Optional)) {
        node = (0, import_core.optional)(node);
      }
      const isUniqueSymbol = (() => {
        if (hasFlag(propertyType, import_typescript.default.TypeFlags.UniqueESSymbol)) {
          return true;
        }
        const propertyWithLink = property;
        if (propertyWithLink.links?.nameType && hasFlag(propertyWithLink.links.nameType, import_typescript.default.TypeFlags.UniqueESSymbol)) {
          return true;
        }
        return false;
      })();
      const symbolType2 = /^__@([^@]+)@/.exec(property.name)?.[1];
      if (isUniqueSymbol && symbolType2) {
        switch (symbolType2) {
          case "toStringTag":
          case "iterator":
          case "asyncIterator":
          case "unscopables": {
            return [`[Symbol.${symbolType2}]`, node];
          }
          default: {
            return [`__uniqueSymbol__${symbolType2}__`, node];
          }
        }
      }
      return [property.name, node];
    });
    const callSignatures = type.getCallSignatures();
    const functionNode = getNodeFromCallSignatures(callSignatures, options);
    if (functionNode) {
      nodes.push(functionNode);
    }
    if (propertyEntries.length > 0) {
      const propertySchemas = Object.fromEntries(propertyEntries);
      nodes.push((0, import_core.object)(propertySchemas));
    }
    if (nodes.length === 1) {
      return nodes[0];
    }
    return (0, import_core.intersection)(nodes);
  }
  if (type.isUnion()) {
    const unionTypes = type.types.map(
      (unionType) => fromTypeInternal({
        ...options,
        type: unionType
      })
    );
    return (0, import_core.union)(unionTypes);
  }
  if (type.isIntersection()) {
    const intersectionTypes = type.types.map(
      (type2) => fromTypeInternal({
        ...options,
        type: type2
      })
    );
    return (0, import_core.intersection)(intersectionTypes);
  }
  if (hasFlag(type, import_typescript.default.TypeFlags.UniqueESSymbol) || "intrinsicName" in type && type.intrinsicName === "symbol") {
    return (0, import_core.symbol)(checker.typeToString(type));
  }
  console.debug("unhandled type", checker.typeToString(type));
  return (0, import_core.symbol)("TRPC_DRIFT_UNHANDLED_TYPE");
};

// src/to-type-node.ts
var import_core2 = require("@onetyped/core");
var import_typescript2 = __toESM(require("typescript"), 1);
var { factory: f } = import_typescript2.default;
var printNode = (node, printerOptions) => {
  const sourceFile = import_typescript2.default.createSourceFile(
    "print.ts",
    "",
    import_typescript2.default.ScriptTarget.Latest,
    false,
    import_typescript2.default.ScriptKind.TS
  );
  const printer = import_typescript2.default.createPrinter(printerOptions);
  return printer.printNode(import_typescript2.default.EmitHint.Unspecified, node, sourceFile);
};
var toTypeNode = (node) => {
  switch (node.typeName) {
    case "definitionReference": {
      return f.createTypeReferenceNode(node.text);
    }
    case "string": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.StringKeyword);
    }
    case "number": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.NumberKeyword);
    }
    case "boolean": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.BooleanKeyword);
    }
    case "null": {
      return f.createLiteralTypeNode(f.createNull());
    }
    case "undefined": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.UndefinedKeyword);
    }
    case "symbol": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.SymbolKeyword);
    }
    case "literal": {
      if (node.type === void 0) {
        return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.UndefinedKeyword);
      }
      switch (typeof node.type) {
        case "string": {
          return f.createLiteralTypeNode(f.createStringLiteral(node.type));
        }
        case "number": {
          return f.createLiteralTypeNode(f.createNumericLiteral(node.type));
        }
        case "boolean": {
          return f.createLiteralTypeNode(
            node.type === true ? f.createTrue() : f.createFalse()
          );
        }
        case "bigint": {
          return f.createLiteralTypeNode(
            f.createBigIntLiteral(node.type.toString())
          );
        }
      }
    }
    case "unknown": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.UnknownKeyword);
    }
    case "void": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.VoidKeyword);
    }
    case "any": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.AnyKeyword);
    }
    case "never": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.NeverKeyword);
    }
    case "regexp": {
      return f.createTypeReferenceNode("RegExp", []);
    }
    case "bigint": {
      return f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.BigIntKeyword);
    }
    case "date": {
      return f.createTypeReferenceNode("Date", []);
    }
    case "file": {
      return f.createTypeReferenceNode("File", []);
    }
    case "blob": {
      return f.createTypeReferenceNode("Blob", []);
    }
    case "formData": {
      return f.createTypeReferenceNode("FormData", []);
    }
    case "object": {
      return f.createTypeLiteralNode(
        Object.entries(node.shape).map(([key, value]) => {
          return f.createPropertySignature(
            void 0,
            key,
            (0, import_core2.isNodeOptional)(value) ? f.createToken(import_typescript2.default.SyntaxKind.QuestionToken) : void 0,
            toTypeNode(value)
          );
        })
      );
    }
    case "array": {
      return f.createArrayTypeNode(toTypeNode(node.type));
    }
    case "set": {
      return f.createTypeReferenceNode("Set", [toTypeNode(node.type)]);
    }
    case "iterator": {
      return f.createTypeReferenceNode("Iterable", [toTypeNode(node.type)]);
    }
    case "record": {
      return f.createTypeReferenceNode("Record", [
        toTypeNode(node.key),
        toTypeNode(node.value)
      ]);
    }
    case "map": {
      return f.createTypeReferenceNode("Map", [
        toTypeNode(node.key),
        toTypeNode(node.value)
      ]);
    }
    case "function": {
      return f.createFunctionTypeNode(
        void 0,
        node.arguments.map(
          (argument, index) => f.createParameterDeclaration(
            void 0,
            void 0,
            `args_${index}`,
            void 0,
            toTypeNode(argument)
          )
        ),
        node.return ? toTypeNode(node.return) : f.createKeywordTypeNode(import_typescript2.default.SyntaxKind.VoidKeyword)
      );
    }
    case "custom": {
      return f.createTypeReferenceNode(
        node.name,
        node.arguments?.map((argument) => toTypeNode(argument))
      );
    }
    case "union": {
      return f.createUnionTypeNode((0, import_core2.mapMultipleInnerNode)(node, toTypeNode));
    }
    case "tuple": {
      return f.createTupleTypeNode((0, import_core2.mapMultipleInnerNode)(node, toTypeNode));
    }
    case "intersection": {
      return f.createIntersectionTypeNode(
        (0, import_core2.mapMultipleInnerNode)(node, toTypeNode)
      );
    }
    case "named": {
      return f.createTypeReferenceNode(node.name);
    }
    case "circular": {
      return f.createLiteralTypeNode(f.createStringLiteral("[Circular]"));
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  fromType,
  printNode,
  toTypeNode
});
